"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
process.env.FORCE_COLOR = '1'; //强迫支持颜色
var fs = require("mz/fs");
var path = require("path");
var yargs = require("yargs");
var hljs = require("highlight.js");
var emphasize = require('emphasize');
function supportsLanguage(name) {
    return !!hljs.getLanguage(name);
}
yargs
    .usage(['', 'Usage: catc  [file]', '', 'Outputs a file or STDIN input with syntax highlighting'].join('\n'))
    .option('language', {
    alias: 'l',
    nargs: 1,
    description: 'Set the langugage explicitely\nIf omitted will try to auto-detect',
})
    .version()
    .help('help')
    .alias('help', 'h')
    .alias('version', 'v');
var argv = yargs.argv;
var file = argv._[0];
var codePromise;
if (!file && !process.stdin.isTTY) {
    // Input from STDIN
    process.stdin.setEncoding('utf8');
    var code_1 = '';
    process.stdin.on('readable', function () {
        var chunk = process.stdin.read();
        if (chunk !== null) {
            code_1 += chunk;
        }
    });
    codePromise = new Promise(function (resolve) {
        process.stdin.on('end', function () {
            var chunk = process.stdin.read();
            if (chunk !== null) {
                code_1 += chunk;
            }
            resolve(code_1);
        });
    });
}
else if (file) {
    // Read file
    codePromise = fs.readFile(file, 'utf-8');
}
else {
    yargs.showHelp();
    process.exit(1);
    throw new Error();
}
process.stdout.write('\n');
Promise.all([codePromise])
    .then(function (_a) {
    var code = _a[0];
    var language = argv.language;
    if (!language && file) {
        var ext = path.extname(file).substr(1);
        if (ext && supportsLanguage(ext)) {
            language = ext;
        }
    }
    return new Promise(function (resolve, reject) {
        if (language) {
            code = emphasize.highlight(language, code).value;
        }
        else {
            code = emphasize.highlightAuto(code).value;
        }
        process.stdout.write(code, function (err) { return (err ? reject(err) : resolve()); });
    });
})
    .then(function () {
    process.exit(0);
})
    .catch(function (err) {
    console.error(err);
    process.exit(1);
});
//# sourceMappingURL=cli.js.map